=== added file '.bzrignore'
--- .bzrignore	1970-01-01 00:00:00 +0000
+++ .bzrignore	2006-09-29 12:17:19 +0000
@@ -0,0 +1,1 @@
+build

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2006-09-28 06:35:56 +0000
+++ olive/__init__.py	2006-09-29 12:17:19 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
-import os.path
 import sys
 
 try:
@@ -23,10 +22,12 @@
     pygtk.require("2.0")
 except:
     pass
+
 import gtk
 import gtk.gdk
 import gtk.glade
 
+from bzrlib.branch import Branch
 import bzrlib.errors as errors
 from bzrlib.workingtree import WorkingTree
 
@@ -48,6 +49,8 @@
         print _('Glade file cannot be found.')
         sys.exit(1)
 
+from dialog import error_dialog, info_dialog
+
 class OliveGtk:
     """ The main Olive GTK frontend class. This is called when launching the
     program. """
@@ -166,29 +169,27 @@
             self.combobox_drive.show()
             self.gen_hard_selector()
         
-        # Load default data into the panels
-        self.treeview_left = self.toplevel.get_widget('treeview_left')
-        self.treeview_right = self.toplevel.get_widget('treeview_right')
         self._load_left()
 
         # Apply menu state
         self.menuitem_view_show_hidden_files.set_active(self.pref.get_preference('dotted_files', 'bool'))
 
         self.set_path(os.getcwd())
+        self._load_right()
 
     def set_path(self, path):
         self.path = path
         self.notbranch = False
         try:
             self.wt, self.wtpath = WorkingTree.open_containing(self.path)
-        except NotBranchError:
+        except errors.NotBranchError:
             self.notbranch = True
-        self._load_right()
 
     def get_path(self):
         return self.path
    
     def on_about_activate(self, widget):
+        from dialog import about
         about()
         
     def on_menuitem_add_files_activate(self, widget):
@@ -217,9 +218,6 @@
     
     def on_menuitem_branch_missing_revisions_activate(self, widget):
         """ Branch/Missing revisions menu handler. """
-        
-        import bzrlib
-        
         local_branch = self.wt.branch
         
         other_branch = local_branch.get_parent()
@@ -244,7 +242,6 @@
 
     def on_menuitem_branch_pull_activate(self, widget):
         """ Branch/Pull menu handler. """
-        
         branch_to = self.wt.branch
 
         location = branch_to.get_parent()
@@ -262,11 +259,15 @@
         if branch_to.get_parent() is None:
             branch_to.set_parent(branch_from.base)
 
-        old_rh = branch_to.revision_history()
-        if tree_to is not None:
-            tree_to.pull(branch_from)
-        else:
-            branch_to.pull(branch_from)
+        #old_rh = branch_to.revision_history()
+        #if tree_to is not None:
+        #    tree_to.pull(branch_from)
+        #else:
+        #    branch_to.pull(branch_from)
+        branch_to.pull(branch_from)
+        
+        # TODO: get the number of pulled revisions
+        ret = 0
         
         info_dialog(_('Pull successful'), _('%d revision(s) pulled.') % ret)
     
@@ -284,20 +285,22 @@
     
     def on_menuitem_branch_initialize_activate(self, widget):
         """ Initialize current directory. """
+        import bzrlib.bzrdir as bzrdir
+        
         try:
             if not os.path.exists(self.path):
                 os.mkdir(self.path)
      
             try:
                 existing_bzrdir = bzrdir.BzrDir.open(self.path)
-            except NotBranchError:
+            except errors.NotBranchError:
                 bzrdir.BzrDir.create_branch_convenience(self.path)
             else:
                 if existing_bzrdir.has_branch():
                     if existing_bzrdir.has_workingtree():
-                        raise AlreadyBranchError(self.path)
+                        raise errors.AlreadyBranchError(self.path)
                     else:
-                        raise BranchExistsWithoutWorkingTree(self.path)
+                        raise errors.BranchExistsWithoutWorkingTree(self.path)
                 else:
                     existing_bzrdir.create_branch()
                     existing_bzrdir.create_workingtree()
@@ -367,7 +370,7 @@
    
     def on_menuitem_view_show_hidden_files_activate(self, widget):
         """ View/Show hidden files menu handler. """
-        self.set_preference('dotted_files', widget.get_active())
+        self.pref.set_preference('dotted_files', widget.get_active())
 
     def on_treeview_left_button_press_event(self, widget, event):
         """ Occurs when somebody right-clicks in the bookmark list. """
@@ -393,32 +396,37 @@
     def on_treeview_right_button_press_event(self, widget, event):
         """ Occurs when somebody right-clicks in the file list. """
         if event.button == 3:
+            # Create a menu
+            from menu import OliveMenu
+            menu = OliveMenu(self.get_path(), self.get_selected_right())
             # get the menu items
-            m_add = self.menu.ui.get_widget('/context_right/add')
-            m_remove = self.menu.ui.get_widget('/context_right/remove')
-            m_commit = self.menu.ui.get_widget('/context_right/commit')
-            m_diff = self.menu.ui.get_widget('/context_right/diff')
+            m_add = menu.ui.get_widget('/context_right/add')
+            m_remove = menu.ui.get_widget('/context_right/remove')
+            m_commit = menu.ui.get_widget('/context_right/commit')
+            m_diff = menu.ui.get_widget('/context_right/diff')
             # check if we're in a branch
             try:
                 from bzrlib.branch import Branch
                 Branch.open_containing(self.get_path())
+                m_add.set_sensitive(True)
+                m_remove.set_sensitive(True)
+                m_commit.set_sensitive(True)
+                m_diff.set_sensitive(True)
+            except errors.NotBranchError:
                 m_add.set_sensitive(False)
                 m_remove.set_sensitive(False)
                 m_commit.set_sensitive(False)
                 m_diff.set_sensitive(False)
-            except errors.NotBranchError:
-                m_add.set_sensitive(True)
-                m_remove.set_sensitive(True)
-                m_commit.set_sensitive(True)
-                m_diff.set_sensitive(True)
-            self.menu.right_context_menu().popup(None, None, None, 0,
-                                                 event.time)
+            menu.right_context_menu().popup(None, None, None, 0,
+                                            event.time)
         
     def on_treeview_right_row_activated(self, treeview, path, view_column):
         """ Occurs when somebody double-clicks or enters an item in the
         file list. """
         import os.path
         
+        from launch import launch
+        
         newdir = self.get_selected_right()
         
         if newdir == '..':
@@ -865,7 +873,8 @@
         """
         if self.config.has_option('preferences', option):
             if kind == 'bool':
-                return self.config.getboolean('preferences', option)
+                #return self.config.getboolean('preferences', option)
+                return True
             elif kind == 'int':
                 return self.config.getint('preferences', option)
             elif kind == 'float':

=== modified file 'olive/add.py'
--- olive/add.py	2006-09-27 21:05:19 +0000
+++ olive/add.py	2006-09-29 12:17:19 +0000
@@ -14,6 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+import os
 import sys
 
 try:
@@ -29,6 +30,7 @@
 import bzrlib.errors as errors
 
 from olive import gladefile
+from dialog import error_dialog
 
 class OliveAdd:
     """ Display the Add file(s) dialog and perform the needed actions. """
@@ -63,22 +65,27 @@
             
             if filename is None:
                 error_dialog(_('No file was selected'),
-                                         _('Please select a file from the list,\nor choose the other option.'))
+                             _('Please select a file from the list,\nor choose the other option.'))
                 return
             
+            if self.wtpath == "":
+                fullpath = self.wt.abspath(filename)
+            else:
+                fullpath = self.wt.abspath(self.wtpath + os.sep + filename)
+            
             try:
-                bzrlib.add.smart_add([directory + '/' + filename])
+                bzrlib.add.smart_add([fullpath])
             except errors.NotBranchError:
                 error_dialog(_('Directory is not a branch'),
-                                         _('You can perform this action only in a branch.'))
+                             _('You can perform this action only in a branch.'))
                 return
         elif radio_unknown.get_active():
             # Add unknown files recursively
             try:
-                bzrlib.add.smart_add([directory], True)
+                bzrlib.add.smart_add([self.wtpath], True)
             except errors.NotBranchError:
                 error_dialog(_('Directory is not a branch'),
-                                         _('You can perform this action only in a branch.'))
+                             _('You can perform this action only in a branch.'))
                 return
         
         self.close()

=== modified file 'olive/dialog.py'
--- olive/dialog.py	2006-09-27 20:30:59 +0000
+++ olive/dialog.py	2006-09-29 12:17:19 +0000
@@ -21,9 +21,12 @@
     pygtk.require("2.0")
 except:
     pass
+
 import gtk
 import gtk.glade
 
+from olive import gladefile
+
 def about():
 	""" Display the AboutDialog. """
 	import olive

=== modified file 'olive/menu.py'
--- olive/menu.py	2006-09-27 20:30:59 +0000
+++ olive/menu.py	2006-09-29 12:17:19 +0000
@@ -26,13 +26,15 @@
 import gtk
 
 import bzrlib.errors as errors
-from dialog import error_dialog
+from bzrlib.workingtree import WorkingTree
 
+from dialog import error_dialog, info_dialog, warning_dialog
 from launch import launch
+from olive import OlivePreferences
 
 class OliveMenu:
     """ This class is responsible for building the context menus. """
-    def __init__(self):
+    def __init__(self, path, selected):
         # Load the UI file
         if sys.platform == 'win32':
             self.uifile = os.path.dirname(sys.executable) + "/share/olive/cmenu.ui"
@@ -48,6 +50,15 @@
                 print _('UI description file cannot be found.')
                 sys.exit(1)
         
+        # Preferences handler
+        self.pref = OlivePreferences()
+        
+        # Set default values
+        self.path = path
+        self.selected = selected
+        print "DEBUG: path =", self.path
+        print "DEBUG: selected =", self.selected
+        
         # Create the file list context menu
         self.ui = gtk.UIManager()
         
@@ -106,18 +117,19 @@
         self.toolbar_diff = self.ui.get_widget('/toolbar_diff')
         
         # Set icons
-        commit_menu = self.ui.get_widget('/context_right/commit')
-        commit_image = self.comm.menuitem_branch_commit.get_image()
-        commit_pixbuf = commit_image.get_pixbuf()
-        commit_icon = gtk.Image()
-        commit_icon.set_from_pixbuf(commit_pixbuf)
-        commit_menu.set_image(commit_icon)
-        diff_menu = self.ui.get_widget('/context_right/diff')
-        diff_image = self.comm.menuitem_stats_diff.get_image()
-        diff_pixbuf = diff_image.get_pixbuf()
-        diff_icon = gtk.Image()
-        diff_icon.set_from_pixbuf(diff_pixbuf)
-        diff_menu.set_image(diff_icon)
+        # TODO: do it without using deprecated comm
+        #commit_menu = self.ui.get_widget('/context_right/commit')
+        #commit_image = self.comm.menuitem_branch_commit.get_image()
+        #commit_pixbuf = commit_image.get_pixbuf()
+        #commit_icon = gtk.Image()
+        #commit_icon.set_from_pixbuf(commit_pixbuf)
+        #commit_menu.set_image(commit_icon)
+        #diff_menu = self.ui.get_widget('/context_right/diff')
+        #diff_image = self.comm.menuitem_stats_diff.get_image()
+        #diff_pixbuf = diff_image.get_pixbuf()
+        #diff_icon = gtk.Image()
+        #diff_icon.set_from_pixbuf(diff_pixbuf)
+        #diff_menu.set_image(diff_icon)
 
     def right_context_menu(self):
         return self.cmenu_right
@@ -127,9 +139,11 @@
     
     def add_file(self, action):
         """ Right context menu -> Add """
+        import bzrlib.add
+        
         # Add only the selected file
-        directory = self.comm.get_path()
-        filename = self.comm.get_selected_right()
+        directory = self.path
+        filename = self.selected
             
         if filename is None:
             error_dialog(_('No file was selected'),
@@ -142,14 +156,12 @@
             error_dialog(_('Directory is not a branch'),
                          _('You can perform this action only in a branch.'))
             return
-        
-        self.comm.refresh_right()
     
     def remove_file(self, action):
         """ Right context menu -> Remove """
         # Remove only the selected file
-        directory = self.comm.get_path()
-        filename = self.comm.get_selected_right()
+        directory = self.path
+        filename = self.selected
         
         if filename is None:
             error_dialog(_('No file was selected'),
@@ -157,46 +169,44 @@
             return
         
         try:
-            wt, path = WorkingTree.open_containing(directory+'/'+filename)
+            wt, path = WorkingTree.open_containing(directory + os.sep + filename)
             wt.remove(path)
 
         except errors.NotBranchError:
             error_dialog(_('Directory is not a branch'),
-                                     _('You can perform this action only in a branch.'))
+                         _('You can perform this action only in a branch.'))
             return
         except errors.NotVersionedError:
             error_dialog(_('File not versioned'),
-                                     _('The selected file is not versioned.'))
+                         _('The selected file is not versioned.'))
             return
-        
-        self.comm.refresh_right()
 
     def open_file(self, action):
         """ Right context menu -> Open """
         # Open only the selected file
-        filename = self.comm.get_selected_right()
+        filename = self.selected
         
         if filename is None:
             error_dialog(_('No file was selected'),
-                                     _('Please select a file from the list,\nor choose the other option.'))
+                         _('Please select a file from the list,\nor choose the other option.'))
             return
 
         if filename == '..':
-            self.comm.set_path(os.path.split(self.comm.get_path())[0])
+            # TODO: how to enter a directory?
+            return
         else:
-            fullpath = self.comm.get_path() + os.sep + filename
+            fullpath = self.path + os.sep + filename
             if os.path.isdir(fullpath):
                 # selected item is an existant directory
-                self.comm.set_path(fullpath)
+                # TODO: how to enter a directory?
+                return
             else:
                 launch(fullpath) 
-        
-        self.comm.refresh_right()
 
     def commit(self, action):
         """ Right context menu -> Commit """
         from commit import OliveCommit
-        wt, path = WorkingTree.open_containing(self.comm.get_path())
+        wt, path = WorkingTree.open_containing(self.path)
         commit = OliveCommit(wt, path)
         commit.display()
     
@@ -208,33 +218,31 @@
     
     def bookmark(self, action):
         """ Right context menu -> Bookmark """
-        if self.comm.pref.add_bookmark(self.comm.get_path()):
+        if self.pref.add_bookmark(self.comm.get_path()):
             info_dialog(_('Bookmark successfully added'),
-                                    _('The current directory was bookmarked. You can reach\nit by selecting it from the left panel.'))
+                        _('The current directory was bookmarked. You can reach\nit by selecting it from the left panel.'))
         else:
             warning_dialog(_('Location already bookmarked'),
-                                       _('The current directory is already bookmarked.\nSee the left panel for reference.'))
-        
-        self.comm.refresh_left()
+                           _('The current directory is already bookmarked.\nSee the left panel for reference.'))
 
     def edit_bookmark(self, action):
         """ Left context menu -> Edit """
         from bookmark import OliveBookmark
 
-        if self.comm.get_selected_left() != None:
-            bookmark = OliveBookmark(self.comm)
+        if self.selected != None:
+            bookmark = OliveBookmark()
             bookmark.display()
 
     def remove_bookmark(self, action):
         """ Left context menu -> Remove """
         
-        if self.comm.get_selected_left() != None:
-            self.comm.pref.remove_bookmark(self.comm.get_selected_left())
+        if self.selected != None:
+            self.pref.remove_bookmark(self.comm.get_selected_left())
             self.comm.refresh_left()
     
     def open_folder(self, action):
         """ Left context menu -> Open Folder """
-        path = self.comm.get_selected_left()
+        path = self.selected
 
         if path != None:
             launch(path)

